syms x y;
%Funktion abgeaendert, für die ursprüngliche Wahl auf dem Übungsblatt konvergiert das
%Newton-Verfahren nicht. 
f(x,y)=sqrt(10*x^2+y^2+1);
grad_f=gradient(f);
Hess_f=hessian(f);
z0=[0.5 0.5];
gamma=0.01;
eta=0.9;
beta=0.5;

[z1, fz1] = Newton(f,grad_f,Hess_f,z0)
[z2,fz2] = Gradient_Powell_Wolfe(f,grad_f,z0,gamma,eta)
%[z3,fz3]=gradarmijo( f, grad_f, z0, beta, gamma);




figure;
hold on;
X=[-2:0.01:2];
Y=[-2:0.01:2];
[X,Y]=meshgrid(X,Y);
Z=sqrt(10*X.^2+Y.^2+1);
contour(X,Y,Z,20);
%plot(z1(:,1),z1(:,2),'r-x')
plot(z2(:,1),z2(:,2),'b--x')
%plot(z3(:,1),z3(:,2),'g:x')
legend('Höhenlinien','Newton','Powell-Wolfe')
xlabel('x')
ylabel('y')



function [z, fz] = Newton(f,grad_f,Hess_f,z0)
z=z0;
fz=f(z(1),z(2));
gradfz=grad_f(z(1),z(2))';

while(norm(gradfz(end,:))>10^(-8))
    A=Hess_f(z(end,1),z(end,2));
    b=-gradfz(end,:)';
   d=A\b;
   z(end+1,:)=(z(end,:)'+d)';
   fz=f(z(end,1),z(end,2));
   gradfz=grad_f(z(end,1),z(end,2))';
    
end


end

function [z,fz] = Gradient_Powell_Wolfe(f,grad_f,z0,gamma,eta)

z=z0;
fz=f(z(1),z(2));
gradfz=grad_f(z(1),z(2))';
k=0;
while(norm(gradfz(end,:))>10^(-7))
k=k+1;
d=-gradfz(end,:);
smin=1;
y=z(end,:)+smin*d;

   while(f(y(1),y(2))>fz(end)+gamma*smin*gradfz(end,:)*d')
     smin=smin/2;
     y=z(end,:)+smin*d;
   end
   splus=smin;


   while(f(y(1),y(2))<=fz(end)+gamma*splus*gradfz(end,:)*d')
      splus=2*splus;
      y=z(end,:)+splus*d;
   end
   y=z(end,:)+smin*d;
   
   while(grad_f(y(end,1),y(end,2))'*d'<eta*gradfz(end,:)*d')
      
       s=(smin+splus)/2;
       y=z(end,:)+s*d;
       if(f(y(1),y(2))<=fz(end,:)+gamma*s*gradfz(end,:)*d')
           smin=s;
       else
           splus=s;
       end
   end
   s=smin;
       
   z(end+1,:)=z(end,:)+s*d;
   fz(end+1)=f(z(end,1),z(end,2));
   gradfz(end+1,:)=grad_f(z(end,1),z(end,2));
   
end
end



